#include <semaphore.h>
#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>
#define NTHREADS 2

// objetcif: cooperation entre deux threads, exécuter "avant" puis "ensuite"
sem_t semaphore;

void *avant(void * param) {
	// do something
	printf("begin executing function avant...\n");  ;
	int j;
	for(j=0;j<1000000;j++) {}
	sem_post(&semaphore);
	printf("finish executing function avant...\n");
	return(NULL);
}

void *ensuite(void * param) {
	sem_wait(&semaphore);
	printf("begin executing function ensuite...\n");  
	// do something
	int j;
	 for(j=0;j<1000000;j++) {}
	printf("finish executing function ensuite...\n");  
	return(NULL);
}

int main (int argc, char *argv[])  {
	pthread_t thread[NTHREADS];
	void * (* func[])(void *)={avant, ensuite};
	int err,i;

	err=sem_init(&semaphore, 0,0);// (0,0) : (signifie entre threads du même processus, initialisaion du semaphore à 0)
	if(err!=0) {
	      error(err,"sem_init");
	}
	for(i=0;i<NTHREADS;i++) {
		err=pthread_create(&(thread[i]),NULL,func[i],NULL);
		if(err!=0) {
			error(err,"pthread_create");
	    	}
	}
	for( i=0;i<NTHREADS;i++) {
    		err=pthread_join(thread[i],NULL);
    		if(err!=0) {
      		error(err,"pthread_join");
    		}
	}
	err=sem_destroy(&semaphore);
	if(err!=0) {
	      error(err,"sem_destroy");
  	}
	return(EXIT_SUCCESS);
}
