
/*Join is a functionality of Pthread library which allows the originating thread to wait for the completion of all its spawned thread's tasks.

Without join the originating thread would exit as soon as it completes its chores, completely ignoring the states of its spawned threads. Due to this, even if any of the spawned threads is in middle of its chore, it'll simply get aborted.

*/

#include <stdio.h>
#include <unistd.h>
#include <pthread.h>



void * printmyid(void * arg)
{
	int *j=(int *)arg;	
	printf("%d: I m thread of id %lu \n",*j, pthread_self());
	pthread_exit(NULL);
}

void main()
{
	//int lines[10]={1,2,3,4,5,6,7,8,9,10};
	pthread_t threads[10];
	for (int i=0; i<10;i++)
		pthread_create(&threads[i],NULL,printmyid,(void*)&i);
	for (int j=0; j<10;j++)
		pthread_join(threads[j],NULL);
	pthread_exit(NULL);
}

