#include <semaphore.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

// on définit un nouveau type barrier_t

typedef struct {
	pthread_mutex_t count_lock;// protéger l'accès à "count"
	pthread_cond_t ok_to_proceed; // var condition
	int count;// compte le nombre de threads qui sont arrivés au niveau de la barrière
} barrier_t;


void barrier_init(barrier_t *b) {
	pthread_mutex_init(&(b->count_lock), NULL);
	pthread_cond_init(&(b->ok_to_proceed), NULL);
	b->count = 0; 
}

// declaration et initialisation d'une variable globale de type barrier_t
barrier_t bar;

int nb_threads=5;// nombre de threads

void barrier (barrier_t *b, int num_threads){
	pthread_mutex_lock(&(b->count_lock));
	b->count++;
	if (b->count == num_threads) {
		b->count = 0;// remettre le nombre de threads à 0 ==> utile pour le else
		pthread_cond_broadcast(&(b->ok_to_proceed));
	}
	else {
		while (b->count != 0)
			pthread_cond_wait(&(b->ok_to_proceed), &(b->count_lock));// libérer
			//le mutex count_lock puis recompétition pour l'avoir en cas de réveil
	}
	pthread_mutex_unlock(&(b->count_lock));
}

void * samplefunction(void * arg)
{
	printf("Thread %lu finished step 1...\n", pthread_self());
	
// debut section critique	

	barrier(&bar,nb_threads);

// fin section critique

	printf("thread %lu begins step 2... \n",pthread_self());
	pthread_exit (NULL);
}

void main()
{	
	barrier_init(&bar);
	pthread_t thread_id[nb_threads];
	
	int i;
	for (i=0;i<nb_threads;i++)
	pthread_create (&thread_id[i], NULL, &samplefunction, NULL);

	for (i=0;i<nb_threads;i++)
	pthread_join(thread_id[i], NULL);
	
	pthread_exit (NULL);
}

