// producteur consommateur tampon borné avec synchronisation thread par varibales conditionnelles

//A condition variable is used to wait until a particular condition is true.
//Condition variables must be used in conjunction with a mutex lock. This
//implements a monitor  

// java implements monitors

#define MAX 100
#include <pthread.h>
#include <string.h>
#include <stdio.h>

static char buffer[MAX]; /*Tampon partagee de taille = MAX*/
static pthread_cond_t libre, plein;
static pthread_mutex_t protect;
int count=0;// nombre de cases occupées

void init_prodcons (void) /* ----- Initialise le producteur/consommateur ----------*/
{ 
	int i;
	pthread_mutex_init(&protect, NULL); 
	pthread_cond_init(&libre, NULL);
	pthread_cond_init(&plein, NULL); 
//	for (i=0;i<MAX;i++) buffer[i] = NULL; 
}

void *deposer(char *msg)
{ 
	pthread_mutex_lock(&protect);
	while (count == MAX) // le while ici est nécessaire en cas de plusieurs producteurs(bien qu'il parait qu'un "if" suffit)
		pthread_cond_wait(&libre, &protect); // en attendant, libérer protect et l'avoir en retour
	// i.e : releases the associated mutex (protect) before blocking and reacquires it before returning. 
	//Because reacquisition of the mutex may be blocked by other threads waiting for the mutex, 
	//the condition that caused the wait must be retested
	// deposer objet
	// buffer = strdup(msg);
	count++;
	printf("P +++++++ %d \n", count);
	pthread_cond_signal(&plein);
	pthread_mutex_unlock(&protect);
	return NULL;
}

void *retirer(void)
{
	char *result;
	pthread_mutex_lock(&protect);
	while (count == 0) // le while ici est nécessaire en cas de plusieurs consommateurs (bien qu'il parait qu'un "if" suffit)
		pthread_cond_wait(&plein, &protect);
	// retirer objet et le consommer
	// result = buffer; buffer = NULL;
	count--;
	printf("C --------- %d\n", count);
	pthread_cond_signal(&libre);
	pthread_mutex_unlock(&protect);
	//return result;
}

void * prod ()
{
	int i=0;
	while (i<200) // produire 200 objets	
	{
		// produire objet
		deposer("salam");	
		i++;
	}
}

void * cons ()
{
	int i=0;
	while (i<200) // produire 200 objets	
	{
		// produire objet
		retirer();	
		i++;	
	}
}

int main()
{
	pthread_t thread1, thread2;
	pthread_create (&thread1, NULL, prod, NULL);
	pthread_create (&thread2, NULL, cons, NULL);
	pthread_join(thread1, NULL);
	pthread_join(thread2, NULL);
	return 0;
		
}

